/*
Scrivere un programma per la gestione delle informazioni relative alle prenotazioni di un ristorante. Ciascuna prenotazione e' caratterizzata dalle seguente informazioni: nome cliente,  giorno della prenotazione,  ora, numero persone. 
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
 1) Lettura da file delle prenotazioni precedentemente salvate relative a un certo giorno.
 2) Inserimento di un nuova prenotazione;
 3) Visualizzazione delle prenotazione relative a un certo giorno;
 4) Salvataggio su file delle informazioni relative alle prenotazioni.

*/

#include <stdio.h>
#include <string.h>

typedef struct {
	char nome[40];
	char data[12];
	int ora,npersone;
} prenotazione;

long dim_file (FILE *pf);
void leggi(prenotazione *pp);
void inserisci(prenotazione *V, int *pn, prenotazione p);
void leggi_da_file(prenotazione *V, int *pn);
void visualizza(prenotazione *V, int n);
void salva(prenotazione *V, int n);
void menu();

int main() {
  prenotazione A[10],p;
  int n=0,scelta;

  do {
	  menu();
	  scanf("%d",&scelta);
	  switch(scelta) {
		  case 1:  leggi_da_file(A,&n);
		  		   break;
		  case 2:  if(n<10) {
			       leggi(&p);
				   inserisci(A,&n,p);
				   }
				   break;
		  case 3:  visualizza(A,n);
		  		   break;
		  case 4:  salva(A,n);
		           break;
		  default:; }
  } while (scelta!=0);
}

long dim_file (FILE *pf)
{
 long cur,dim;
  cur=ftell(pf);
  fseek(pf,0,SEEK_END);
  dim=ftell(pf);
  fseek(pf,cur,SEEK_SET);
  return dim;
}

void leggi(prenotazione *pp)
{
	printf("Nome: "); scanf("%s",pp->nome);
	printf("Data: "); scanf("%s",pp->data);
	printf("Ora: "); scanf("%d",&pp->ora);
	printf("N.persone: "); scanf("%d",&pp->npersone);

}
void inserisci(prenotazione *V, int *pn, prenotazione p)
{
	V[*pn]=p;
	(*pn)++;
}

void leggi_da_file(prenotazione *V, int *pn)
{
 int i,dim;
 FILE *pf;
 char data[12];
 prenotazione p;

 pf=fopen("prenota.dat","r");
 if(pf==NULL) return;
 printf("Data: ");
 scanf("%s",data);
 dim=dim_file(pf)/sizeof(prenotazione);
 for(i=0;i<dim;i++)
  {fread(&p,sizeof(prenotazione),1,pf);
   if(strcmp(data,p.data)==0)
  	inserisci(V,pn,p);
  }
 fclose(pf);
}

void visualizza(prenotazione *V, int n)
{
	int i;
    char data[12];

	printf("Data: ");
	scanf("%s",data);
	for(i=0;i<n;i++)
		if(strcmp(data,V[i].data)==0)
			{ printf("Nome: %s\n",V[i].nome);
			  printf("Ora: %d\n",V[i].ora);
			  printf("N.persone: %d\n",V[i].npersone);
		    }
}

void salva(prenotazione *V, int n)
{
	FILE *pf;

 pf=fopen("prenota.dat","w");
 if(pf==NULL) return;
 fwrite(V,sizeof(prenotazione),n,pf);
 fclose(pf);
}

void menu()
{
	printf("Scegli una delle seguenti opzioni\n");
	printf("1) Lettura da file\n");
	printf("2) Inserimento\n");
	printf("3) Visualizzazione\n");
	printf("4) Salvataggio\n");
	printf("0) fine\n\n");

}






