/*
Scrivere un programma per la gestione delle informazioni relative alle operazioni eseguite presso un ufficio postale. Ciascuna operazione  caratterizzata dalle seguente informazioni: nome cliente, importo delloperazione, giorno delloperazione, tipo di operazione (0=raccomandata, 1=pagamento). 
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
 1) Inserimento di una nuova operazione;
 2) Visualizzazione delle operazioni relative a un certo tipo;
 3) Salvataggio su file delle informazioni relative alle operazioni di un certo tipo.

Si assuma che allavvio del programma vengano lette da file le informazioni, relative alle operazioni, precedentemente salvate.

*/

#include <stdio.h>

typedef struct {
	char nome[40];
	int importo;
	char data[12];
	int tipo;
} operazione;


void leggi(operazione *op);
void inserisci(operazione *V, int *pn, operazione op);
void inizializza(operazione *V, int *pn);
void visualizza(operazione *V, int n);
void salva(operazione *V, int n);
void menu();

int main() {
	operazione A[10],op;
	int n=0,scelta;

	inizializza(A,&n);
	do {
		menu();
		scanf("%d",&scelta);
		switch(scelta) {
			case 1: if(n<10) {
				     leggi(&op);
					 inserisci(A,&n,op);
					}
					 break;
			case 2: visualizza(A,n);
					break;
			case 3: salva(A,n);
				    break;
			default:;  }
		} while (scelta!=0);

}

void leggi(operazione *op)
{
	printf("Nome: "); scanf("%s",op->nome);
	printf("Importo: "); scanf("%d",&op->importo);
	printf("Data: "); scanf("%s",op->data);
	printf("Tipo: "); scanf("%d",&op->tipo);

}

void inserisci(operazione *V, int *pn, operazione op)
{
	V[*pn]=op;
	(*pn)++;
}

void inizializza(operazione *V, int *pn)
{
	FILE *pf;
	int i=0;

	pf=fopen("operaz.dat","r");
	if(pf==NULL) return;
	while( fread(&V[i],sizeof(operazione),1,pf)!=0)
		i++;
	*pn=i;
	fclose(pf);

}

void visualizza(operazione *V, int n)
{
	int tipo,i;

	printf("Tipo: "); scanf("%d",&tipo);
	for(i=0;i<n;i++)
		if(V[i].tipo==tipo)
			{ printf("Nome: %s\n",V[i].nome);
	          printf("Importo: %d\n",V[i].importo);
		      printf("Data: %s\n",V[i].data);
		    }
}

void salva(operazione *V, int n)
{

	FILE *pf;
	int tipo,i;

	printf("Tipo: "); scanf("%d",&tipo);

	pf=fopen("operaz.dat","w");
	if(pf==NULL) return;
	for(i=0;i<n;i++)
		if(V[i].tipo==tipo)
			fwrite(&V[i],sizeof(operazione),1,pf);
	fclose(pf);
}

void menu()
{
	printf("\nScegli una delle opzioni\n");
	printf("1) Inserisci\n");
	printf("2) Visualizza\n");
	printf("3) Salva\n");
	printf("0) Fine\n\n");
}

