/*
Scrivere un programma per la gestione delle informazioni relative agli iscritti ad un ufficio di collocamento. Ciascun iscritto  caratterizzato dalle seguente informazioni: nominativo,  mesi di anzianit, data di nascita (aaaa/mm/gg), codice del titolo di studio (0=licenza elementare, 1=licenza media, 2=diploma, 3=laurea).
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
 1) Lettura da file delle iscrizioni precedentemente salvate relative a un certo numero di mesi di anzianit.
 2) Inserimento di un nuovo iscritto;
 3) Visualizzazione del nominativo e del titolo di studio dei disoccupati con almeno una certa anzianit;
 4) Salvataggio su file delle informazioni relative ai disoccupati.
*/

#include <stdio.h>
#include <string.h>
#define D 10

typedef struct{
	char nome_cognome[40];
	int mesi;
	char data_di_nascita[12];
	int codice;
} iscritti;


void leggi_file(iscritti *V, int *pn, char *nomefile, int m);
void inserisci(iscritti *V, int *pn);
void visualizza(iscritti *V, int n, int m);
void salva_file(iscritti *V, int n, char *nomefile);
void menu();

int main() {
	iscritti V[D];
	char nomefile[40];
	int mesi, n=0, scelta;
	printf("Inserisci nome del file dove lavorare\n");
	scanf("%s", nomefile);
	do {
		menu();
		scanf("%d", &scelta);
		switch(scelta) {
			case 0: break;
			case 1: printf("Inserisci i mesi di anzianita'\n");
					scanf("%d", &mesi);
					leggi_file(V, &n, nomefile, mesi);
					break;
			case 2: inserisci(V, &n);
					break;
			case 3: printf("Inserisci i mesi di anzianita'\n");
					scanf("%d", &mesi);
					visualizza(V, n, mesi);
					break;
			case 4:	salva_file(V, n, nomefile);
					break;
			default: printf("Tasto errato");
					 break;
		}
	}while (scelta!=0);
}

void menu() {
	printf("Scegli un'operazione:\n");
	printf("1) Lettura da file\n");
	printf("2) Inserimento di un nuovo iscritto\n");
	printf("3) Visualizza iscritti\n");
	printf("4) Salvataggio su file\n");
	printf("0) Esci\n");
}

void leggi_file(iscritti *V, int *pn, char *nomefile, int m) {
	FILE *pf;
	int i=0;
	iscritti temp;
	pf=fopen(nomefile, "r");
	if(pf==NULL) {
		printf("Errore di lettura file!!!\n");
		return;
	}
	while(fread(&temp, sizeof(iscritti), 1, pf)  && i<D)
	   if(temp.mesi==m)
		   {
			V[i]=temp;
			i++;
		   }
	*pn=i;
	fclose(pf);
}

void visualizza(iscritti *V, int n, int m) {
	int i;
	for(i=0; i<n; i++) {
		if(V[i].mesi== m) {
			printf("Nome e cognome: %s\n", V[i].nome_cognome);
			printf("mesi di anzianit: %d\n", V[i].mesi);
			printf("Codice: %d\n", V[i].codice);
		}
	}
}

void inserisci(iscritti *V, int *pn) {
	if(*pn==D) {
		printf("Vettore pieno");
		return;
	}
	printf("Nome e cognome:\n");
	scanf("%s", V[*pn].nome_cognome);
	printf("Mesi di anzianit:\n");
	scanf("%d", &V[*pn].mesi);
	printf("Data di nascita:\n");
	scanf("%s", V[*pn].data_di_nascita);
	printf("Codice:\n");
	scanf("%d", &V[*pn].codice);
	(*pn)++;
}

void salva_file(iscritti *V, int n, char *nomefile) {
	FILE *pf;
	pf=fopen(nomefile, "w");
	if(pf==NULL) {
		printf("Errore in scrittura su file\n");
		return;
	}
	fwrite(V, sizeof(iscritti), n, pf);
	fclose(pf);
}
